
/* mon.c  monitor for command line interpreter
	for Sx simulator		11 July 2006
*/

#include "sx.h"

#define MXBUF  80
#define MXOBUF 2000
#define MXBP  20
#define sep  "\t\n "

#define   PRIVATE  static

PRIVATE int bplist[MXBP], nbp;			/* break points list */
PRIVATE char ibuf[MXBUF], *cp = NULL;	/* input buffer */
PRIVATE char obuf[MXOBUF];
char *cp2 = obuf;						/* output buffer */
PRIVATE FILE *fi;
int disp = 0;					/* display control */

PRIVATE char *tok(void){	/* get one token from input */
	if( cp != NULL ) cp = strtok(NULL,sep);
	while ( cp == NULL ){
		printf(">");
		cp = fgets(ibuf,MXBUF,fi);
		if( cp != NULL ) cp = strtok(ibuf, sep);
	}
	cp = strupr(cp);   /* convert to uppercase */
// printf("%s ",cp);
	return cp;
}
/*
PRIVATE FILE *fo;

PRIVATE void writeobuf(char *name){  // write upto cp2
	fo = fopen(name,"w");
	fwrite(obuf,1,(int)(cp2-obuf),fo);
	fclose(fo);
}

void testtok(){
	char *w;
	fi = stdin;
	cp = NULL;
	while(1){
		w = tok();
		printf("%s ",w);
		if( eqs(w,"QUIT")) break;
	}
}
*/
PRIVATE char  *readA(void){ return tok(); }

PRIVATE void setBp(int ads){
//	bplist[nbp] = ads;
//	nbp++;
//	if( nbp >= MXBP )
//		error("too many breakpoints");
	bplist[0] = ads;
	nbp = 1;
}

PRIVATE int isbreak(void){
	int i;
	for(i=0;i<nbp;i++)
		if( PC == bplist[i] ) return 1;
	return 0;
}

void trace(void){
	while(!isbreak() && runflag) {
//		printf("%d ",PC);
		run3();
		if(disp) showR();
		if(ninst > 1000000) break;
	}
}

PRIVATE void setArg(char *s, int value){
	M[atoi(s)] = value;
}

PRIVATE void dumpMem(int ads, int n){
	int i,k;
	k = 0;
	printf("%4d : ",ads);
	for(i=ads;i<ads+n;i++){
		printf("%d ",M[i]);
		k++;
		if( k%10 == 0 ) printf("\n%4d : ",i+1);
	}
}

PRIVATE void moveMem(int ads1, int ads2, int n){
	int i;
	for(i=0;i<n;i++)
		M[ads2++] = M[ads1++];
}

PRIVATE void help(void){
  printf("%s\n%s\n%s\n",
    "g go, t single step, b set breakpoint, c clear break point",
    "s set ads val, d dump ads n, m move mem a1 a2 n",
    "r register, z 1/0 display, o show output, q quit, h help");
}

void showR(void){
	int i, b;
	printf("PC %d TS %d FP %d SP %d NX %d FF %d Z%d S%d | ",
	  PC,TS,FP,SP,NX,FF,Z,S);
	b = FP - 3;
	if( b < 0 ) b = 0;
	for(i=b; i<=SP; i++)
		if( i == FP ) printf("[%d] ",M[i]);
		else printf("%d ",M[i]);
	printf("{%d %d %d %d}\n",V[3],V[2],V[1],V[0]);
}

void interp(void){
	char *w, *arg, *v, *v2;
	int i, runf;
	runf = 1;
	fi = stdin;
	cp = NULL;
	while(runf){
		w = tok();
		switch( w[0] ){
		case 'G':
			trace();
			break;
		case 'T':					// single step
			run3();
			showR();
			break;
		case 'B':					// set breakpoint
			arg = readA();
			setBp(atoi(arg));
			break;
		case 'C': 					// clear breakpoint
			nbp = 0;
			break;
		case 'S':					// set mem
			arg = readA();
			v = readA();
			setArg(arg,atoi(v));
			break;
		case 'D':					// dump mem
			arg = readA();
			v = readA();
			dumpMem(atoi(arg),atoi(v));
			break;
		case 'M':					// move mem
			arg = readA();
			v = readA();
			v2 = readA();
		    moveMem(atoi(arg),atoi(v),atoi(v2));
			break;
		case 'R': showR();	break;
		case 'Z': disp = atoi(readA()); break;
		case 'O': printf("%s\n",obuf); break;
		case 'Q': runf = 0; break;
		case 'H': help(); break;
		default: printf("unknow command\n");
		}
	}
//	writeobuf("out.txt");
}
