/* sx.h */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "mspec2.h"

// memory  cs[1000], ds[2000], ss[7000]
//        ^          ^        ^         ^
//        0       MAXCS      SSBASE    MAXMEM

#define	MAXCS 1000
#define MAXDS 3000
#define SSBASE 3000
#define MAXMEM 10000
#define MAXV 4			// frame caching size

#define MWIDTH   MAWIDTH+MCWIDTH
//#define MWIDTH		100	// max size
//#define MLEN		100

#define icAdd 1
#define icSub 2
#define icMul 3
#define icDiv 4
#define icBand 5
#define icBor 6
#define icBxor 7
#define icNot 8
#define icEq 9
#define icNe 10
#define icLt 11
#define icLe 12
#define icGe 13
#define icGt 14
#define icShl 15
#define icShr 16
//#define icMod 17
#define icLdx 18
#define icStx 19
#define icRet 20
//#define icRetv 21
#define icArray 22
#define icEnd 23
#define icGet 24
#define icPut 25
#define icLd 26
#define icSt 27
#define icJmp 28
#define icJt 29
#define icJf 30
#define icLit 31
#define icCall 32
//#define icCallt 33
#define icInc 34
#define icDec 35
#define icSys 36
//#define icCase 37
#define icFun 38

#define FP1 39		// alu pass1
#define FP2 40		// alu pass2
#define FZ  41		// alu eq 0
#define FSUB 42		// alu p1 - p2

#define OBJ_SOMv2  5678920

#define eqs(a,b)  (strcmp(a,b)==0)

typedef struct {
	char name[80];
	int val;
} sym;

void error(char *s);
void trap(int op, int arg);

int alu(int op, int a, int b);
void readmpgm(void);
void run3(void);
void show(void);
void showR(void);
void loadobj(char *fn);
void interp(void);
void readmspec(void);
void initrom(void);
void trace(void);
void scan1(int a);

extern int TS, FP, SP, NX, FF, PC, IR, Z, S, M[], V[], U;
extern int tbus, dbus, p1, p2, abus;
extern int mpc;
extern char ms[];
extern int runflag;
extern int clock, ninst;
extern int disp;

extern sym mads[];
extern int mwidth, mawidth, mcwidth, mlen;

